#include <iostream>
#include <map>
#include <string>
#include <syslog.h>
#include <cstring>

#include <boost/extension/extension.hpp>
#include <boost/extension/factory.hpp>
#include <boost/extension/type_map.hpp>

#include <plugins/plugin.hpp>

#include <ndds/ndds_cpp.h>
#include "helloworld_dds.h"
#include "helloworld_ddsSupport.h"

class helloworld_messageListener : public DDSDataReaderListener {
  public:
    virtual void on_requested_deadline_missed(
        DDSDataReader* /*reader*/,
        const DDS_RequestedDeadlineMissedStatus& /*status*/) {}
    
    virtual void on_requested_incompatible_qos(
        DDSDataReader* /*reader*/,
        const DDS_RequestedIncompatibleQosStatus& /*status*/) {}
    
    virtual void on_sample_rejected(
        DDSDataReader* /*reader*/,
        const DDS_SampleRejectedStatus& /*status*/) {}

    virtual void on_liveliness_changed(
        DDSDataReader* /*reader*/,
        const DDS_LivelinessChangedStatus& /*status*/) {}

    virtual void on_sample_lost(
        DDSDataReader* /*reader*/,
        const DDS_SampleLostStatus& /*status*/) {}

    virtual void on_subscription_matched(
        DDSDataReader* /*reader*/,
        const DDS_SubscriptionMatchedStatus& /*status*/) {}

    virtual void on_data_available(DDSDataReader* reader);
};


class helloworld : public plugin {
public:
	helloworld(DDSDomainParticipant *participant);
	virtual void receive_information(void);
private:
	DDSDomainParticipant *participant_;
	DDSSubscriber *subscriber_;
	DDSTopic *topic_;
	helloworld_messageListener *reader_listener_;
	DDSDataReader *reader_;
	DDS_ReturnCode_t retcode_;
	const char *type_name_;
   	int count_;
	DDS_Duration_t receive_period_;
	int status_;
	int sample_count_;
	std::string qos_file_;

};




BOOST_EXTENSION_TYPE_MAP_FUNCTION
{
	using namespace boost::extensions;
	std::map<std::string, factory<plugin, DDSDomainParticipant *> > &plugin_factories(types.get());
	plugin_factories["helloworld"].set<helloworld>();
}




